package mylib;

import java.applet.*;
import java.awt.*;
import java.util.Date;
import mylib.MyFuns;

// a button class for starting/stopping another thread

public final class CalcRunner extends Button
							implements Runnable
{
	Applet	host;
	Runnable calc;
	boolean	running;
	String	labels[] = new String[2];

//	boolean suspended;
	public Thread thrCalc;	// thread for running calculation

	public CalcRunner (Runnable calcObj, Applet parent, String sStart, String sStop )
	{
		super (sStart);
		labels[0] = sStart;
		labels[1]= sStop;
		host = parent;
		calc = calcObj;
	}

    public boolean action( Event evt, Object arg )
	{
		try 
		{
			if (running)
			{
				thrCalc.stop ();
				host.showStatus ("");
			} 
			else
			{
				thrCalc = new Thread (this);
				thrCalc.start ();
			}
			running = ! running;
		}
		catch (Exception e)
		{
			host.showStatus (e.getMessage () );
			if (thrCalc != null && thrCalc.isAlive () )
			{
				thrCalc.stop ();
			}
			running = false;
			thrCalc = null;
		}
		setLabel (labels [running ? 1 : 0]);

		return true;
	}
		

	public final void run ()
	{
		try
		{
			calc.run ();
		}
		catch (Exception e)
		{
			String s = e.getMessage ();
			if (s != "")
				host.showStatus (s);
		}
		running = false;
		setLabel (labels[0]);
		thrCalc = null;
	}

}
