package mylib;

import java.awt.TextArea;
import java.applet.*;
import java.awt.Container;
import java.awt.Event;

public final class DescribedTextArea extends TextArea
{
	String description;
	Container parent;
	boolean altered = false;

	public DescribedTextArea ( Container p, String d)
	{
		super ();
		parent = p;
		description = d;
	}

	public DescribedTextArea ( Container p, String d, int  rows, int  cols)
	{
		super (rows, cols);
		parent = p;
		description = d;
	}
	
	public DescribedTextArea ( Container p, String d, String  text)
	{
		super ( text );
		parent = p;
		description = d;
	}

	public DescribedTextArea ( Container p, String d, String  text, int  rows, int  cols)
	{
		super (text, rows, cols);
		parent = p;
		description = d;
	}

	public boolean mouseEnter(Event  evt, int  x, int  y)
	{
		if (description != null && parent != null)
		{
			if (parent instanceof Applet)
				((Applet)parent).showStatus (description);
			return true;
		}
		return false;
	}

	public boolean mouseExit(Event  evt, int  x, int  y)
	{
		if (description != null && parent != null)
		{
			if (parent instanceof Applet)
				((Applet)parent).showStatus ("");
			return true;
		}
		return false;
	}

	public boolean keyDown(Event  evt, int  key)
	{
		// show the description when user hits F1
		if (key == Event.F1 && description != null && parent != null)
		{
			if (parent instanceof Applet)
				((Applet)parent).showStatus ("");
			return true;
		}
		return false;
	}

	// when this field gets the focus, mark it as changed
	// we would like to do this only on keystrokes that change the window
	// contents, but MS Explorer, at least, doesn't send a Shift-Insert keypress
	// event, and so we couldn't tell if the user has changed the window by
	// pasting

	public boolean handleEvent(Event  evt)
	{
		if (evt.id == Event.MOUSE_UP)
			altered = true;

		return false;
	}


	public void setAltered (boolean a)
	{
		this.altered = a;
	}

	public boolean isAltered ()
	{
		return altered;
	}

}
