package mylib;

import java.awt.TextField;
import java.awt.Component;
import java.applet.*;
import java.awt.Event;

public final class DescribedTextField extends TextField
{
	String description;
	Component parent;

	public DescribedTextField ( Component p, String d)
	{
		super ();
		parent = p;
		description = d;
	}

	public DescribedTextField ( Component p, String d, int  cols)
	{
		super (cols);
		parent = p;
		description = d;
	}
	
	public DescribedTextField ( Component p, String d, String  text)
	{
		super ( text );
		parent = p;
		description = d;
	}

	public DescribedTextField ( Component p, String d, String  text, int  cols)
	{
		super (text, cols);
		parent = p;
		description = d;
	}

	public boolean mouseEnter (Event evt, int  x, int  y)
	{
		if (description != null && parent != null)
		{
			if (parent instanceof Applet)
				((Applet)parent).showStatus (description);
			return true;
		}
		return false;
	}

	public boolean mouseExit (Event evt, int  x, int  y)
	{
		if (description != null && parent != null)
		{
			if (parent instanceof Applet)
				((Applet)parent).showStatus ("");
			return true;
		}
		return false;
	}

	public boolean keyDown(Event  evt, int  key)
	{
		// show the description when user hits F1
		if (key == Event.F1 && description != null && parent != null)
		{
			if (parent instanceof Applet)
				((Applet)parent).showStatus ("");
			return true;
		}
		return false;
	}

}